'use strict';

exports.__esModule = true;

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ManifestProcessor = function (_ResourceProcessorBas) {
    _inherits(ManifestProcessor, _ResourceProcessorBas);

    function ManifestProcessor() {
        _classCallCheck(this, ManifestProcessor);

        return _possibleConstructorReturn(this, _ResourceProcessorBas.apply(this, arguments));
    }

    ManifestProcessor.prototype.processResource = function processResource(manifest, ctx, charset, urlReplacer) {
        var lines = manifest.split('\n');

        for (var i = 0; i < lines.length; i++) {
            var line = lines[i].trim();

            if (line && line !== 'CACHE MANIFEST' && line !== 'NETWORK:' && line !== 'FALLBACK:' && line !== 'CACHE:' && line[0] !== '#' && line !== '*') {

                var isFallbackItem = line.indexOf(' ') !== -1;

                if (isFallbackItem) {
                    var urls = line.split(' ');

                    lines[i] = urlReplacer(urls[0]) + ' ' + urlReplacer(urls[1]);
                } else lines[i] = urlReplacer(line);
            }
        }

        return lines.join('\n');
    };

    ManifestProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.contentInfo.isManifest;
    };

    return ManifestProcessor;
}(_resourceProcessorBase2.default);

exports.default = new ManifestProcessor();
module.exports = exports['default'];