'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

var _instrumented = require('../instrumented');

// Transform:
// obj[prop] = value -->
// __set$(object, prop, value)

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_esotope.Syntax.AssignmentExpression],

    condition: function condition(node) {
        var left = node.left;

        // super[prop] = value
        if (left.type === _esotope.Syntax.MemberExpression && left.object.type === _esotope.Syntax.Super) return false;

        if (node.operator === '=' && left.type === _esotope.Syntax.MemberExpression && left.computed) return left.property.type === _esotope.Syntax.Literal ? (0, _instrumented.shouldInstrumentProperty)(left.property.value) : true;

        return false;
    },

    run: function run(node) {
        return (0, _nodeBuilder.createComputedPropertySetWrapper)(node.left.property, node.left.object, node.right);
    }
}; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

module.exports = exports['default'];