'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// val1 += val2
// --> val1 = val1 + val2

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_esotope.Syntax.AssignmentExpression],

    condition: function condition(node) {
        return node.operator === '+=';
    },

    run: function run(node) {
        return (0, _nodeBuilder.createExpandedConcatOperation)(node.left, node.right);
    }
};
module.exports = exports['default'];