'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _replaceNode = require('./replace-node');

var _replaceNode2 = _interopRequireDefault(_replaceNode);

var _esotope = require('../tools/esotope');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Transform:
// eval(script); --> eval(__proc$Script(script));

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.CallExpression],

    condition: function condition(node) {
        if (!node.arguments.length) return false;

        // eval()
        if (node.callee.type === _esotope.Syntax.Identifier && node.callee.name === 'eval') return true;

        // obj.eval(), obj['eval'](),
        return node.callee.type === _esotope.Syntax.MemberExpression && (node.callee.property.name || node.callee.property.value) === 'eval';
    },

    run: function run(node) {
        var newArg = (0, _nodeBuilder.createProcessScriptMethCall)(node.arguments[0]);

        (0, _replaceNode2.default)(node.arguments[0], newArg, node, 'arguments');

        return null;
    }
}; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

module.exports = exports['default'];