'use strict';

exports.__esModule = true;

var _esotope = require('../tools/esotope');

var _nodeBuilder = require('../node-builder');

var _replaceNode = require('./replace-node');

var _replaceNode2 = _interopRequireDefault(_replaceNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Transform:
// for(obj[prop] in src), for(obj.prop in src) -->
// for(const __set$temp in src) { obj[prop] = __set$temp; }

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.ForInStatement],

    condition: function condition(node) {
        return node.left.type === _esotope.Syntax.MemberExpression;
    },

    run: function run(node) {
        var tempVarAst = (0, _nodeBuilder.createTempVarIdentifier)();
        var varDeclaration = (0, _nodeBuilder.createVarDeclaration)(tempVarAst);
        var assignmentExprStmt = (0, _nodeBuilder.createAssignmentExprStmt)(node.left, tempVarAst);

        (0, _replaceNode2.default)(null, assignmentExprStmt, node.body, 'body');
        (0, _replaceNode2.default)(node.left, varDeclaration, node, 'left');

        return null;
    }
}; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

module.exports = exports['default'];