'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// x = 5; "hello" --> x = 5; parent.__proc$Html(window, "hello")
// someAction(); generateHtmlPage() --> someAction(); parent.__proc$Html(window, generateHtmlPage())

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_esotope.Syntax.ExpressionStatement],

    condition: function condition(node, parent) {
        return parent.wrapLastExprWithProcessHtml && parent.body[parent.body.length - 1] === node;
    },

    run: function run(node, parent) {
        parent.wrapLastExprWithProcessHtml = false;

        return (0, _nodeBuilder.createHtmlProcessorWrapper)(node);
    }
};
module.exports = exports['default'];