'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

var _replaceNode = require('./replace-node');

var _replaceNode2 = _interopRequireDefault(_replaceNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Transform:
// location.field; location[field] -->
// __get$Loc(location).field; __get$Loc(location)[field];

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.MemberExpression],

    condition: function condition(node, parent) {
        // Skip: for(location.field in obj)
        if (parent.type === _esotope.Syntax.ForInStatement && parent.left === node) return false;

        return node.object.name === 'location';
    },

    run: function run(node) {
        (0, _replaceNode2.default)(node.object, (0, _nodeBuilder.createLocationGetWrapper)(), node, 'object');

        return null;
    }
}; // -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

module.exports = exports['default'];