'use strict';

exports.__esModule = true;

var _nodeBuilder = require('../node-builder');

var _esotope = require('../tools/esotope');

// Transform:
// location = value -->
// (function(){ return __set$Loc(location, value) || location = value;}.apply(this))

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_esotope.Syntax.AssignmentExpression],

    condition: function condition(node) {
        return node.operator === '=' && node.left.type === _esotope.Syntax.Identifier && node.left.name === 'location';
    },

    run: function run(node, parent, key) {
        var wrapWithSequence = key !== 'arguments' && key !== 'consequent' && key !== 'alternate' && (parent.type !== _esotope.Syntax.SequenceExpression || parent.expressions[0] === node);

        return (0, _nodeBuilder.createLocationSetWrapper)(node.right, wrapWithSequence);
    }
};
module.exports = exports['default'];