"use strict";

exports.__esModule = true;
exports.createLineIterator = createLineIterator;
exports.appendLine = appendLine;
exports.equals = equals;
// Const
var LF = 0x0A;
var CR = 0x0D;
var CRLF_LENGTH = 2;

var CRLF = exports.CRLF = new Buffer([CR, LF]);

// API
function createLineIterator(buffer) {
    return {
        [Symbol.iterator]: function* () {
            var lastIdx = buffer.length - 1;
            var start = 0;

            for (var i = 0; i < buffer.length; i++) {
                if (i === lastIdx) yield buffer.slice(start);else if (buffer[i] === CR && buffer[i + 1] === LF) {
                    yield buffer.slice(start, i);
                    start = i + CRLF_LENGTH;
                }
            }
        }
    };
}

function appendLine(lines, line) {
    if (lines.length) lines.push(CRLF);

    lines.push(line);
}

function equals(buffer1, buffer2) {
    if (buffer1.length !== buffer2.length) return false;

    for (var i = 0; i < buffer1.length; i++) {
        if (buffer1[i] !== buffer2[i]) return false;
    }

    return true;
}